// #version 330 core

// layout (location = 0) in vec3 vertPos;
// layout (location = 1) in vec3 vertNrm;
// layout (location = 2) in vec2 vertUV;

// uniform mat4 projection;
// uniform mat4 view;
// uniform mat4 model;
// uniform mat3 nrmModel;

// out vec3 vNormal;
// out vec2 vUV;

// void main() {
//     vNormal = vec3(vertNrm) * nrmModel;
//     vUV = vertUV;
//     gl_Position = projection * view * model * vec4(vertPos, 1.0);
// }

#version 330 core

layout (location = 0) in vec3 vertPos;
layout (location = 1) in vec3 vertNrm;
layout (location = 2) in vec2 vertUV;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat3 nrmModel;
uniform mat4 lightSpaceMat;

out vec3 vNormal;
out vec2 vUV;
out vec3 fragPos;
out vec4 fragPosLightSpace;

void main() {
    vNormal = vec3(vertNrm) * nrmModel;
    vUV = vertUV;
    fragPos = vec3(model * vec4(vertPos, 1.0f));
    fragPosLightSpace = lightSpaceMat * vec4(fragPos, 1.0);
    gl_Position = projection * view * model * vec4(vertPos, 1.0);
}
